"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
var _react = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const TICK = require('./assets/tick.png');
const CIRCLE = require('./assets/circle.png');
const SEARCH = require('./assets/search.png');
const MultiSelect = props => {
  const {
    label,
    labelContainerStyle,
    inputContainerStyle,
    labelTextStyle,
    listHeaderContainerStyle,
    footerContainerStyle,
    submitButtonContainerStyle,
    submitButtonTextStyle,
    listContainerStyle,
    listRowStyle,
    searchContainerStyle,
    data,
    uniqueKey,
    displayKey,
    selectedItems,
    defaultValue,
    onSelectedItemsChange,
    mode = 'single',
    theme = '#394867',
    showLabel,
    showListHeader = true,
    showSearch = true,
    backdropOpacity
  } = props;
  const [showListModal, setShowListModal] = (0, _react.useState)(false);
  const [searchText, setSearchText] = (0, _react.useState)('');
  const [list, setList] = (0, _react.useState)(data);
  const [selectedData, setSelectedData] = (0, _react.useState)([]);
  const mappedDataToObject = data.reduce((accumulator, currentValue) => {
    accumulator[currentValue[uniqueKey]] = currentValue[displayKey];
    return accumulator;
  }, {});
  const moveText = (0, _react.useRef)(new _reactNative.Animated.Value(0)).current;
  (0, _react.useEffect)(() => {
    setList(data);
  }, [data]);
  (0, _react.useEffect)(() => {
    if ((selectedItems === null || selectedItems === void 0 ? void 0 : selectedItems.length) > 0) {
      moveTextTop();
    } else if ((selectedItems === null || selectedItems === void 0 ? void 0 : selectedItems.length) === 0) {
      moveTextBottom();
    }
  }, [selectedItems]);
  const moveTextTop = () => {
    _reactNative.Animated.timing(moveText, {
      toValue: 1,
      duration: 100,
      useNativeDriver: false
    }).start();
  };
  const moveTextBottom = () => {
    _reactNative.Animated.timing(moveText, {
      toValue: 0,
      duration: 100,
      useNativeDriver: false
    }).start();
  };
  const selectedItemData = data.filter(item => {
    if (mode === 'single') {
      if ((selectedItems === null || selectedItems === void 0 ? void 0 : selectedItems.length) > 0) {
        return selectedItems[0] === item[uniqueKey];
      }
    } else {
      if (selectedItems.includes(item[uniqueKey])) {
        return true;
      }
    }
  });
  const handleSelectItem = item => {
    if (mode === 'single') {
      onSelectedItemsChange([item[uniqueKey]]);
      setShowListModal(false);
      return;
    }
    setSelectedData(preVal => {
      if (!preVal.includes(item[uniqueKey])) {
        return [...preVal, item[uniqueKey]];
      } else {
        const newVal = preVal.filter(preValItem => preValItem !== item[uniqueKey]);
        return newVal;
      }
    });
  };
  const handleSearch = text => {
    setSearchText(text);
    if (text === '') {
      setList(data);
      return;
    }
    const searchedCity = data.filter(item => item.cityName ? item.cityName.startsWith(text) : item.name ? item.name.startsWith(text) : false);
    if (searchedCity) {
      setList(searchedCity);
    } else {
      setList(data);
    }
  };
  const handleCloseModal = () => {
    setShowListModal(false);
    setList(data);
  };
  const handleSubmit = () => {
    onSelectedItemsChange(selectedData);
    setShowListModal(false);
  };
  const renderListModal = data => {
    const handleRenderHeader = () => /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: _reactNative.StyleSheet.flatten([styles.labelContainer, {
        backgroundColor: theme
      }, listHeaderContainerStyle])
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.labelHeaderText
    }, label), /*#__PURE__*/_react.default.createElement(_reactNative.Pressable, {
      onPress: handleCloseModal
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.closeButtonStyle
    }, "X")));
    const handleRenderItem = _ref => {
      let {
        item
      } = _ref;
      return /*#__PURE__*/_react.default.createElement(_reactNative.Pressable, {
        onPress: () => handleSelectItem(item),
        style: _reactNative.StyleSheet.flatten([styles.dataListContainer, listRowStyle])
      }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: {
          flexDirection: 'row',
          alignContent: 'center'
        }
      }, mode === 'multiple' ? selectedData.includes(item[uniqueKey]) ? /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
        source: TICK,
        style: _reactNative.StyleSheet.flatten([styles.selectedItemIcon, {
          tintColor: theme
        }])
      }) : /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
        source: CIRCLE,
        style: _reactNative.StyleSheet.flatten([styles.selectedItemIcon, {
          tintColor: theme
        }])
      }) : selectedData.includes(item[uniqueKey]), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: {
          flex: 1
        }
      }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
        style: styles.listItemText
      }, item[displayKey]))));
    };
    return /*#__PURE__*/_react.default.createElement(_reactNative.Modal, {
      transparent: true,
      visible: showListModal
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Pressable, {
      style: _reactNative.StyleSheet.flatten([styles.overlay, {
        opacity: backdropOpacity
      }]),
      onPress: handleCloseModal
    }), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.modalContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: _reactNative.StyleSheet.flatten([styles.listContainer, listContainerStyle])
    }, showListHeader && handleRenderHeader(), showSearch ? /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: _reactNative.StyleSheet.flatten([styles.search, searchContainerStyle])
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: SEARCH,
      style: _reactNative.StyleSheet.flatten([styles.searchIcon, {
        tintColor: theme
      }])
    }), /*#__PURE__*/_react.default.createElement(_reactNative.TextInput, {
      autoCapitalize: "words",
      autoCorrect: false,
      style: {
        width: 150
      },
      value: searchText,
      onChangeText: handleSearch,
      placeholder: "Search"
    })) : null, /*#__PURE__*/_react.default.createElement(_reactNative.FlatList, {
      data: list,
      renderItem: handleRenderItem,
      keyExtractor: (item, index) => index.toString()
    }), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: footerContainerStyle
    }, mode === 'multiple' && /*#__PURE__*/_react.default.createElement(_reactNative.Pressable, {
      onPress: handleSubmit,
      style: _reactNative.StyleSheet.flatten([styles.submitButton, {
        backgroundColor: theme
      }, submitButtonContainerStyle])
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: _reactNative.StyleSheet.flatten([styles.buttonTextStyle, submitButtonTextStyle])
    }, "Submit"))))));
  };
  const handlePickerPress = () => {
    setShowListModal(true);
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.container
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Pressable, {
    onPress: handlePickerPress,
    style: _reactNative.StyleSheet.flatten([styles.pickerContainer, {
      color: theme,
      borderColor: theme
    }, inputContainerStyle])
  }, showLabel && /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.labelTextContainer, labelContainerStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: _reactNative.StyleSheet.flatten([styles.label, {
      color: theme
    }, labelTextStyle])
  }, label)), selectedItemData ? /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: {
      flexDirection: 'row'
    }
  }, mode === 'single' ? /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: styles.selectedText
  }, selectedItemData[0][displayKey]) : selectedItemData.splice(0, 4).map((item, index) => /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.selectedTextContainer
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    key: index,
    style: styles.selectedText
  }, mappedDataToObject[item[uniqueKey]])))) : /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: {
      flexDirection: 'row'
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: styles.selectedText
  }, defaultValue))), renderListModal(data));
};
var _default = MultiSelect;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  container: {
    flex: 1
  },
  pickerContainer: {
    borderColor: '#394867',
    borderWidth: 1,
    backgroundColor: '#fff',
    justifyContent: 'center',
    height: 50
  },
  search: {
    flexDirection: 'row',
    borderColor: '#000',
    height: 50,
    borderWidth: 1,
    paddingLeft: 10,
    margin: 10,
    alignItems: 'center',
    borderRadius: 50
  },
  listContainer: {
    flex: 0.7,
    backgroundColor: 'white',
    marginHorizontal: 30
  },
  modalContainer: {
    flex: 1,
    justifyContent: 'center'
  },
  dataListContainer: {
    borderBottomWidth: 1,
    borderBottomColor: '#a1a1a1'
  },
  selectedItemIcon: {
    color: '#394867',
    tintColor: '#394867',
    alignSelf: 'center',
    left: 10,
    height: 35,
    width: 35
  },
  searchIcon: {
    tintColor: '#394867',
    height: 35,
    width: 35
  },
  listItemText: {
    color: '#333',
    padding: 18
  },
  rightIconStyle: {
    paddingHorizontal: 5
  },
  labelContainer: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    padding: 15,
    backgroundColor: '#394867'
  },
  labelTextContainer: {
    backgroundColor: '#fff',
    alignSelf: 'flex-start',
    paddingHorizontal: 10,
    marginStart: 25,
    zIndex: 1,
    elevation: 1,
    shadowColor: '#fff',
    position: 'absolute',
    top: -12
  },
  labelText: {
    position: 'absolute',
    left: 12,
    fontSize: 18,
    color: '#aaa',
    fontWeight: 'normal'
  },
  labelHeaderText: {
    color: '#fff',
    fontWeight: 'bold',
    fontSize: 17
  },
  selectedText: {
    color: '#333',
    marginLeft: 5
  },
  overlay: {
    position: 'absolute',
    bottom: 0,
    top: 0,
    left: 0,
    right: 0,
    backgroundColor: '#000',
    opacity: 0.8
  },
  submitButton: {
    height: 40,
    width: 280,
    marginVertical: 15,
    bottom: -2,
    alignSelf: 'center',
    alignItems: 'center',
    justifyContent: 'center',
    borderRadius: 10,
    backgroundColor: '#394867'
  },
  buttonTextStyle: {
    color: '#fff'
  },
  closeButtonStyle: {
    color: '#fff',
    fontSize: 22
  },
  label: {
    color: '#394867',
    fontSize: 12
  },
  selectedTextContainer: {
    borderRadius: 50,
    paddingVertical: 5,
    paddingHorizontal: 20,
    borderColor: '#000',
    borderWidth: 1,
    marginHorizontal: 5
  }
});
//# sourceMappingURL=index.js.map